package virus;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.*;
import java.util.Observer;
import javax.imageio.ImageIO;

/**
 *
 */
public class Microscope implements Observer {

    private JLabel widget;
    private String dir;

    public Microscope(JPanel owner){

        dir = System.getProperty(("user.dir"));
        dir += "\\images\\";

        // Read image
        try {
            BufferedImage myPicture = ImageIO.read(new File(dir + "RedBlood.jpg"));
            widget = new JLabel(new ImageIcon(myPicture));
        } catch (Exception e) {}

        // Setup JPanel
        widget.setOpaque(false); // Ensure background is visible.
        Dimension size = new Dimension(80, 80);
	widget.setSize(size);
	widget.setPreferredSize(size);

        owner.add(widget);
	

    }

    public void setLocation(Point location) {
        widget.setLocation(location);
    }

    public void setImage(String cellType) {

        // Load Image
        try {
            BufferedImage myPicture = ImageIO.read(new File(dir + cellType + ".jpg"));
            widget.setIcon(new ImageIcon(myPicture));
        } catch (Exception e) {}
    }

    public void update(Observable o, Object arg) {
        setLocation(((RedBlood) o).getLocation());
        setImage(((RedBlood) o).getCellType());
    }
}
