package virus;

import java.awt.*; 
import javax.swing.Timer;
import java.awt.event.*;
import java.util.*;

/**
 *
 */
public class VirusApp {

    private SimGUI gui;
    private javax.swing.Timer timer;
    private Map<Integer, Cell> petridish;
    private boolean wobble;


    public static void main(String[] args)
    {
        VirusApp app = new VirusApp();
        app.Start();
    }


    private VirusApp() {

        // Instatilise variables
        wobble = false;
        gui = new SimGUI();
        petridish = new HashMap<Integer, Cell>();

        // Setup the JFrame
        SetupPetridish();

        // Make a timer
        timer = new javax.swing.Timer(100, new ActionListener() {
	        public void actionPerformed(ActionEvent e) {
                    Simulate();

	        }
	    });

        // Start the timer.
        timer.setInitialDelay(0);

    }

    private void SetupPetridish() {

        Integer n = 0;

        // Create a 6 x 8 grid of Cells
        for (Integer i = 1; i <= 8; i++) {
            for (Integer j = 1; j <= 6; j++) {

                Point p = new Point((i*100) - 90, (j*100) - 90);
                Cell cell = SetupCell(p);

                petridish.put(n,cell);
                n++;
            }
        }
        
        // Setup the mutated cells
        Iterator<Map.Entry<Integer, Cell>> mapIter
                = petridish.entrySet().iterator();
        while (mapIter.hasNext()) {

            Map.Entry<Integer,Cell> entry = mapIter.next();
            Cell c = entry.getValue();

            // If top left make it a virus
            if (c.getLocation().getX() < 100 && c.getLocation().getY() < 100) {
                
                c = new Virus(c);
                entry.setValue(c);
            }
            
            // If top right make it a Dendrite
            if (c.getLocation().getX() > 700 && c.getLocation().getY() < 100) {
                
                c = new Dendrite(c);
                entry.setValue(c);
            }
            
            // If bottom left make it an Lymphocyte
            if (c.getLocation().getX() < 100 && c.getLocation().getY() > 500) {
                
                c = new Lymphocyte(c);
                entry.setValue(c);
            }
            
            // If bottom right make it an Eosinophil
            if (c.getLocation().getX() > 700 && c.getLocation().getY() > 500) {
                
                c = new Eosinophil(c);
                entry.setValue(c);
            }
        }
    }


    private Cell SetupCell(Point location) {
        RedBlood cell = new RedBlood(location);
        cell.addObserver(gui.makeMicroscope());

        return cell;
    }

    private void Start() {
        timer.start();
    }

    private void Simulate() {
        
        Iterator<Map.Entry<Integer, Cell>> mapIter = petridish.entrySet().iterator();

        // Make the cells active
        while (mapIter.hasNext()) {
            Map.Entry<Integer,Cell> entry = mapIter.next();

            Cell c = entry.getValue();
            Point p = c.getLocation();
            int wobbleRate = c.getWobble();

            if (wobble) {
                p.translate(-wobbleRate,-wobbleRate);
            } else {
                p.translate(wobbleRate,wobbleRate);
            }

            c.setLocation(p);
            entry.setValue(c);
        }

        // Set wobble backwards
        if (wobble) {
            wobble = false;
        } else {
            wobble = true;
        }
        
    }

}
